Package com.orchestranetworks.userservice

# Interface UserServiceResourceLocator

All Superinterfaces:
  `UIResourceLocator`

All Known Subinterfaces:
  `UserServiceDisplayConfigurator`, `UserServiceEventContext`, `UserServiceGetCreatedRecordContext<S>`, `UserServiceInitializeContext<S>`, `UserServicePaneWriter`, `UserServiceRawPaneWriter`, `UserServiceWriter`

public interface UserServiceResourceLocator extends UIResourceLocator
This interface defines methods to build URLs that are useful for a user service.

Since:
  5.8.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getURLForAction(UserServiceEvent aCallback)`
  Returns a URL that will trigger an action event when clicked by a user.
  `String`
  `getURLForAction(UserServiceEvent aCallback, URLQuery aQuery)`
  Returns a URL that will trigger an action event when clicked by a user.
  `String`
  `getURLForAjaxRequest(UserServiceAjaxRequest aCallback)`
  Returns a URL that will invoke an Ajax request callback.
  `String`
  `getURLForAjaxRequest(UserServiceAjaxRequest aCallback, URLQuery aQuery)`
  Returns a URL that will invoke an Ajax request callback.
  `String`
  `getURLForEndingService()`
  Returns a user interface URL indicating that the execution of this service is finished.
  `String`
  `getURLForGetRequest(UserServiceGetRequest aCallback)`
  Returns a URL that will invoke a GET request callback.
  `String`
  `getURLForGetRequest(UserServiceGetRequest aCallback, URLQuery aQuery)`
  Returns a URL that will invoke a GET request callback.
  `String`
  `getURLForResource(String aModuleName, String aResourcePath)`
  Returns the URL string for the specified web resource.
  `String`
  `getURLForResource(String aModuleName, String aResourcePath, URLQuery aQuery)`
  Returns the URL string for the specified web resource.
  `String`
  `getURLForServiceSelection(Adaptation aRecordOrInstance, SchemaNode aNode, ServiceKey aServiceKey)`
  Deprecated.
  Instead use {`getURLForServiceSelection(ServiceKey, Adaptation, SchemaNode, URLQuery)`.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey)`
  Returns a user interface URL to start the specified service.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrDataSet)`
  Returns a user interface URL which selects the specified record or dataset and starts the specified service on it.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey, AdaptationHome aDataSpaceOrSnapshot)`
  Returns a user interface URL that selects the specified dataspace or snapshot and starts the specified service on it.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey, AdaptationHome aDataSpaceOrSnapshot, URLQuery aQuery)`
  Returns a user interface URL that selects the specified dataspace or snapshot and starts the specified service on it.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrInstance, SchemaNode aNode)`
  Returns a user interface URL which selects the specified node of the given record or dataset and starts the specified service on it.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrInstance, SchemaNode aNode, URLQuery aQuery)`
  Returns a user interface URL which selects the specified node of the given record or dataset and starts the specified service on it.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrDataSet, URLQuery aQuery)`
  Returns a user interface URL which selects the specified record or dataset and starts the specified service on it.
  `String`
  `getURLForServiceSelection(ServiceKey aServiceKey, URLQuery aQuery)`
  Returns a user interface URL to start the specified service.

  ### Methods inherited from interface com.orchestranetworks.ui.UIResourceLocator

  `createWebComponentForRootSession, createWebComponentForSubSession, getURLForAjaxComponent, getURLForAjaxComponent, getURLForPerspectiveSelection, getURLForPerspectiveSelection, getURLForResource, getURLForResource, getURLForResource, getURLForResource, getURLForResource, getURLForRest, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForViewSelection`

- ## Method Details

  - ### getURLForAction

    String getURLForAction(UserServiceEvent aCallback)
    Returns a URL that will trigger an action event when clicked by a user.

    Calling this method has the same result as calling `getURLForAction(aCallback, null)`.

    Parameters:
      `aCallback` - the callback that will be called when receiving the action event.
    Returns:
      the URL.

  - ### getURLForAction

    String getURLForAction(UserServiceEvent aCallback, URLQuery aQuery)
    Returns a URL that will trigger an action event when clicked by a user.
    Parameters:
      `aCallback` - the callback that will be called when receiving the action event.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the URL.
    Since:
      5.8.1

  - ### getURLForAjaxRequest

    String getURLForAjaxRequest(UserServiceAjaxRequest aCallback)
    Returns a URL that will invoke an Ajax request callback.

    Calling this method has the same result as calling `getURLForAjaxRequest(aCallback, null)`.

    Parameters:
      `aCallback` - the callback that will be called when receiving the action event.
    Returns:
      the URL.

  - ### getURLForAjaxRequest

    String getURLForAjaxRequest(UserServiceAjaxRequest aCallback, URLQuery aQuery)
    Returns a URL that will invoke an Ajax request callback.
    Parameters:
      `aCallback` - the callback that will be called when receiving the action event.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the URL.
    Since:
      5.8.1

  - ### getURLForGetRequest

    String getURLForGetRequest(UserServiceGetRequest aCallback)
    Returns a URL that will invoke a GET request callback.

    Calling this method has the same result as calling `getURLForGetRequest(aCallback, null)`.

    Parameters:
      `aCallback` - the callback that will be called when receiving the action event.
    Returns:
      the URL.

  - ### getURLForGetRequest

    String getURLForGetRequest(UserServiceGetRequest aCallback, URLQuery aQuery)
    Returns a URL that will invoke a GET request callback.
    Parameters:
      `aCallback` - the callback that will be called when receiving the action event.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the URL.
    Since:
      5.8.1

  - ### getURLForEndingService

    String getURLForEndingService()
    Returns a user interface URL indicating that the execution of this service is finished.

    If the service was displayed in a pop-up window, the latter is closed automatically.

    For a user service form, the action is the same as clicking on a default close button.

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey)
    Returns a user interface URL to start the specified service. When the URL is accessed, the service will be launched on the current content, unless this service automatically selects its own target content (for example, `ServiceKey.WORKFLOW`).
    Parameters:
      `aServiceKey` - the service key.
    Returns:
      the absolute URL.

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey, URLQuery aQuery)
    Returns a user interface URL to start the specified service. When the URL is accessed, the service will be launched on the current content, unless this service automatically selects its own target content (for example, `ServiceKey.WORKFLOW`).
    Parameters:
      `aServiceKey` - the service key.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the URL.
    Since:
      5.8.1

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey, AdaptationHome aDataSpaceOrSnapshot)
    Returns a user interface URL that selects the specified dataspace or snapshot and starts the specified service on it.
    Parameters:
      `aServiceKey` - the service key.
      `aDataSpaceOrSnapshot` - the dataspace or snapshot.
    Returns:
      the absolute URL.

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey, AdaptationHome aDataSpaceOrSnapshot, URLQuery aQuery)
    Returns a user interface URL that selects the specified dataspace or snapshot and starts the specified service on it.
    Parameters:
      `aServiceKey` - the service key.
      `aDataSpaceOrSnapshot` - the dataspace or snapshot.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the absolute URL.
    Since:
      5.8.1

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrDataSet)
    Returns a user interface URL which selects the specified record or dataset and starts the specified service on it.

    Calling this method has the same result as calling `getURLForServiceSelection(aServiceKey, aRecordOrInstance, aNode, URLQuery)`.

    Parameters:
      `aServiceKey` - the service key.
      `aRecordOrDataSet` - the record or dataset.
    Returns:
      the absolute URL.

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrDataSet, URLQuery aQuery)
    Returns a user interface URL which selects the specified record or dataset and starts the specified service on it.
    Parameters:
      `aServiceKey` - the service key.
      `aRecordOrDataSet` - the record or dataset.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the absolute URL.
    Since:
      5.8.1

  - ### getURLForServiceSelection

    @Deprecated String getURLForServiceSelection(Adaptation aRecordOrInstance, SchemaNode aNode, ServiceKey aServiceKey)
    Deprecated.
    Instead use {`getURLForServiceSelection(ServiceKey, Adaptation, SchemaNode, URLQuery)`.

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrInstance, SchemaNode aNode)
    Returns a user interface URL which selects the specified node of the given record or dataset and starts the specified service on it.
    Parameters:
      `aServiceKey` - the service key.
      `aRecordOrInstance` - the dataspace or snapshot.
      `aNode` - the node.
    Returns:
      the absolute URL.

  - ### getURLForServiceSelection

    String getURLForServiceSelection(ServiceKey aServiceKey, Adaptation aRecordOrInstance, SchemaNode aNode, URLQuery aQuery)
    Returns a user interface URL which selects the specified node of the given record or dataset and starts the specified service on it.
    Parameters:
      `aServiceKey` - the service key.
      `aRecordOrInstance` - the dataspace or snapshot.
      `aNode` - the node.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the absolute URL.
    Since:
      5.8.1

  - ### getURLForResource

    String getURLForResource(String aModuleName, String aResourcePath)
    Returns the URL string for the specified web resource.

    Calling this method has the same result as calling `getURLForResource(aModuleName, aResourcePath, URLQuery)`.

    Parameters:
      `aModuleName` - the name of the module containing the resource.
      `aResourcePath` - must begin with a "/" and is interpreted as relative to the specified module (web application) root.
    Returns:
      the URL.

  - ### getURLForResource

    String getURLForResource(String aModuleName, String aResourcePath, URLQuery aQuery)
    Returns the URL string for the specified web resource.
    Parameters:
      `aModuleName` - the name of the module containing the resource.
      `aResourcePath` - must begin with a "/" and is interpreted as relative to the specified module (web application) root.
      `aQuery` - query that is added to the URL. May be `null`.
    Returns:
      the URL.
    Since:
      5.8.1